import 'package:test/test.dart';
import 'package:wialon/wialon.dart';

void main() async {
  String token = const String.fromEnvironment("WIALON_TOKEN");

  test("Login", () async {
    WialonSdk sdk = WialonSdk();
    expect(sdk.sessionId, isNull);

    Map<String, dynamic> result = await sdk.login(token: token);
    await sdk.logout();
    expect(result['eid'], isNotNull);
  });

  test("getUnits", () async {
    WialonSdk sdk = WialonSdk();
    expect(sdk.sessionId, isNull);

    await sdk.login(token: token);
    Map<String, dynamic> result = await sdk.call(
      method: 'core/search_items',
      parameters: {
        'spec': {
          'itemsType': 'avl_unit',
          'propName': 'sys_name',
          'propValueMask': '*',
          'sortType': 'sys_name',
          'or_logic': true,
        },
        'force': 1,
        'flags': 1,
        'from': 0,
        'to': 0
      },
    );
    await sdk.logout();
    expect(result['totalItemsCount'], 1);
    expect(result['totalItemsCount'], result['items'].length);
  });

  test("reverseGeocoding", () async {
    WialonSdk sdk = WialonSdk();
    expect(sdk.sessionId, isNull);

    await sdk.login(token: token);
    String result = await sdk.reverseGeocoding(latitude: 9.0817275, longitude: -79.5932219);
    await sdk.logout();
    expect(result, isNotEmpty);
  });
}
